//I can sensor You
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeSans9pt7b.h>
#include <Fonts/FreeMonoOblique9pt7b.h>
#include <DHT.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

#define sensor    A0 
#define DHTPIN 5          // Digital pin 2
#define DHTTYPE DHT11     // DHT 11
#include <Stepper.h>
const int stepsPerRevolution = 90;
      //int variable for gas level
String quality =""; 
DHT dht(DHTPIN, DHTTYPE);

int Analog_Eingang = A0;
float Analog;
Stepper myStepper(stepsPerRevolution, 8, 9, 10, 11);
int stepCount = 0;  // number of steps the motor has taken

void sendSensor()
{
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  if (isnan(h) || isnan(t)) {
  Serial.println("Failed to read from DHT sensor!");
    return;
  }
  display.setTextColor(WHITE);
  display.setTextSize(1);
  display.setFont();
  display.setCursor(0, 43);
  display.println("Temp  :");
  display.setCursor(50, 43);
  display.println(t);
  display.setCursor(90, 43);
  display.println("C");
  display.setCursor(0, 56);
  display.println("Hum   :");
  display.setCursor(50, 56);
  display.println(h);
  display.setCursor(90, 56);
  display.println("%");
}

void mic_sensor()
{
  float Analog;
  int Digital;
  Analog = analogRead (Analog_Eingang) * (5.0 / 1023.0); 
  if(Analog <1.00){
    quality = "ALARM!";
  }
  else if (Analog >1.00 && Analog<3.00){
    quality = "NORMAL";
  }
  else if (Analog >3.00){
    quality = "QUIET!!!!";
  }
    else{
    quality = "!!!!!!!";   
    }
  
  display.setTextColor(WHITE);
  display.setTextSize(1);  
  display.setCursor(1,5);
  display.setFont();
  display.println(Analog);
  display.setTextSize(1);
  display.setCursor(20,23);
  display.setFont(&FreeMonoOblique9pt7b);
  display.println(quality); 
  Serial.println(Analog);
}

void setup() {
  Serial.begin(9600);
  pinMode(sensor,INPUT);
  dht.begin();
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3c)) 
  { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
  }
  display.clearDisplay();
  display.setTextColor(WHITE);
  

  display.setTextSize(1);
  display.setCursor(20, 20);
  display.println("I can sensor you");
  display.display();
  delay(1200);
  display.clearDisplay();
  
  display.setTextSize(2);
  display.setCursor(5,20);
  display.println("By Tatjana");
  display.display();
  delay(1000);
  display.clearDisplay();    
}

void loop() {
display.clearDisplay();
mic_sensor();
sendSensor();
display.display();  
int sensorReading = analogRead(A0);
  // map it to a range from 0 to 100:
  int motorSpeed = map(sensorReading, 0, 1023, 0, 90);
  // set the motor speed:
  if (motorSpeed > 0) {
    myStepper.setSpeed(motorSpeed);
    // step 1/100 of a revolution:
    myStepper.step(stepsPerRevolution / 90);
  } 

}
